import { GeneratorInterface } from "./generator.interface";
import { AsyncSubject } from "rxjs";
import 'rxjs/add/operator/takeUntil';
import { ConfigInterface } from "./config.interface";
import 'rxjs/add/observable/forkJoin';
export declare class Generator implements GeneratorInterface {
    private config;
    private template;
    static debugPrefix: string;
    private gitlabApi;
    constructor(config: ConfigInterface, template: string);
    generate(): AsyncSubject<string>;
    private readonly logger;
    private processChangelogDataToMarkdownFile(changelogData);
    private onAllMilestonesDataProcessed(milestonesDataProcessings);
    private processMilestoneData(ms, allRequestsObservables, changelogData);
    private processMilestoneMergeRequestsData(id, milestoneData, fetchingRequest);
    private awaitMilestones();
    private awaitMilestoneMergeRequests(milestoneId);
    private toObservable(cb);
}
