"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_interface_1 = require("./config.interface");
const generator_1 = require("./generator");
const template_1 = require("./template");
let options = require('minimist')(process.argv.slice(2));
if (!options.token || !options.url || !options.projectId || !options.destFile) {
    console.error(generator_1.Generator.debugPrefix, 'you must passing these arguments: token, url, projectId, destFile');
    process.exit(1);
}
let logLevel = config_interface_1.LOG_LEVEL.LOG;
if (options.logLevel) {
    console.info(generator_1.Generator.debugPrefix, 'logLevel options set to', options.logLevel);
    logLevel = config_interface_1.LOG_LEVEL[`${options.logLevel}`];
}
let config = {
    gitlab: {
        token: options.token,
        url: options.url
    },
    projectId: options.projectId,
    destFile: options.destFile,
    logLevel: logLevel
};
let generator = new generator_1.Generator(config, template_1.template);
generator.generate()
    .subscribe((status) => {
    console.info(generator_1.Generator.debugPrefix, 'Succeeded', `status: ${status}`);
}, (status) => {
    console.info(generator_1.Generator.debugPrefix, 'Error', `status: ${status}`);
});
